/*
	AppKitDefines.h
	Application Kit
	Copyright (c) 1995-1996, NeXT Software, Inc.
	All rights reserved.
*/
#ifndef _APPKITDEFINES_H
#define _APPKITDEFINES_H

//
//  Platform specific defs for externs
//

//
// For MACH
//

#if defined(__MACH__)

#ifdef __cplusplus
// This isnt extern "C" because the compiler will not allow this if it has
// seen an extern "Objective-C"
#define APPKIT_EXTERN		extern
#define PRIVATE_EXTERN		__private_extern__
#else
#define APPKIT_EXTERN		extern
#define PRIVATE_EXTERN		__private_extern__
#endif

#define APPKIT_EXTERN_IMP	PUBLIC_EXTERN
#define PRIVATE_EXTERN_IMP	PRIVATE_EXTERN


//
// For Windows
//

#elif defined(WIN32)

#ifndef _NSBUILDING_APPKIT_DLL
#define _NSWINDOWS_DLL_GOOP	__declspec(dllimport)
#else
#define _NSWINDOWS_DLL_GOOP	__declspec(dllexport)
#endif

#ifdef __cplusplus
#define APPKIT_EXTERN		_NSWINDOWS_DLL_GOOP extern "C"
#define PRIVATE_EXTERN		extern "C"
#else
#define APPKIT_EXTERN		_NSWINDOWS_DLL_GOOP extern
#define PRIVATE_EXTERN		extern
#endif

#define APPKIT_EXTERN_IMP	PUBLIC_EXTERN
#define PRIVATE_EXTERN_IMP	PRIVATE_EXTERN


//
//  For Solaris
//

#elif defined(SOLARIS)

#ifdef __cplusplus
#define APPKIT_EXTERN		extern "C"
#define PRIVATE_EXTERN		extern "C"
#else
#define APPKIT_EXTERN		extern
#define PRIVATE_EXTERN		extern
#endif

#define APPKIT_EXTERN_IMP	APPKIT_EXTERN
#define PRIVATE_EXTERN_IMP	PRIVATE_EXTERN


#endif

#endif // _APPKITDEFINES_H

