/*
  You may freely copy, distribute, and reuse the code in this example.
  NeXT disclaims any warranty of any kind, expressed or implied, as to its
  fitness for any particular use.
*/

#import <AppKit/AppKit.h>

@interface CalendarMatrix : NSMatrix
{
    id	monthName;
    id  leftButton;
    id  rightButton;
    
    NSCalendarDate *selectedDay;
    short startOffset;
}

- (void)choseDay:sender;
- (void)monthChanged:sender;

- (void)refreshCalendar;
- (id)initWithFrame:(NSRect)frameRect;
- (void)dealloc;
- (void)setSelectedDay:(NSCalendarDate *)newDay;
- (NSCalendarDate *)selectedDay;

@end

@interface NSObject(CalendarMatrixDelegate)
- (void)calendarMatrix:(CalendarMatrix *)object didChangeToDate:(NSDate *)date;
- (void)calendarMatrix:(CalendarMatrix *)object
      didChangeToMonth:(int)month
                  year:(int)year;

@end
