// InformixContext.h 
// Copyright (c) 1994, NeXT Software, Inc.  All rights reserved.
//

#import <EOAccess/EOAccess.h>
#import "InformixDefines.h"

@class InformixAdaptor;
@class InformixChannel;

@interface InformixContext:EOAdaptorContext
{
    unsigned short _fetchesInProgress;
    unsigned short _openCursors;
    BOOL _hasTransactions;
    BOOL _isANSI;
    BOOL _isOnLine;
    BOOL _connected;
    int  _infVers;
    InformixIsolationLevel _defaultIsolation;
    long _last_serial;
    long _connection;
}

- initWithInformixAdaptor:(InformixAdaptor *)adaptor;
    
- (unsigned)fetchesInProgress;

- (void)connect;
- (void)disconnect;
- (BOOL)isConnected;

- (BOOL)informixChannelWillBeginFetching:(InformixChannel *)cursor;
- (void)informixChannelDidEndFetching:(InformixChannel *)cursor;
- (void)informixChannelWillOpen:(InformixChannel *)cursor;
- (void)informixChannelDidClose:(InformixChannel *)cursor;
    // Methods used by the adaptor to notify the context of changes.

- (long)getInformixSerialValue;
- (void)setInformixSerialValue:(long)serial;
- (BOOL)isOnLine;
    // Is the server an Informix-OnLine server
- (BOOL)hasTransactions;
    // Does the server support transactions
- (InformixIsolationLevel)defaultIsolation;
    // Isolation setting on the server
- (void)setInformixPDQPriority:(const char*)prio;
- (long)connection;
    // The informiox connection structure

@end

