// OracleChannel.h 
// Copyright (c) 1994, NeXT Software, Inc.  All rights reserved.

#import <EOAccess/EOAccess.h>

@class OracleContext;

@interface OracleChannel:EOAdaptorChannel
{
    struct cda_def *_cda;
    id _currentExpression;    
    NSArray *_selectedAttributes;
    NSMutableArray *_selectedColumns;
    unsigned _fetchBufferLength;
    unsigned _rowCapacity;
    unsigned _rowsInBuffer;
    unsigned _nextRowInBuffer;
    unsigned _rowsProcessedCount;
    NSMutableArray *_bindVariables;
    NSString *_lastStatementParsed;
    BOOL _beganTransaction;
    BOOL _fetchInProgress;
    BOOL _opened;
    struct cda_def *_extraCda;
}

- initWithOracleContext:(OracleContext *)logon;

- (struct cda_def *)cursorDataArea;
    // This returns NULL if the channel is not connected.

- (void)setFetchBufferLength:(unsigned)length;
- (unsigned)fetchBufferLength;
    // These are to manipulate how much memory to use as a fetch buffer.  The
    // larger the buffer, the more rows that can be returned for each round
    // trip to the server.

- (void)raiseOracleError;
    // Used internally for error checking. Examines oracle structures for error
    // flags and raises an exception if one is found.
@end

