// OracleContext.h 
// Copyright (c) 1994, NeXT Software, Inc.  All rights reserved.

#import <EOAccess/EOAccess.h>

@class OracleAdaptor;
@class OracleChannel;

@interface OracleContext:EOAdaptorContext
{
    void *_lda;
    unsigned char _hda[256];
    unsigned short _fetchesInProgress;
    unsigned short _openCursors;
    BOOL _connected;
}

- initWithOracleAdaptor:(OracleAdaptor *)adaptor;

- (void *)logonDataArea;
- (unsigned char *)hostDataArea;
    // These return NULL if the context is not connected.
    
- (unsigned)fetchesInProgress;

- (void)connect;
- (void)disconnect;
- (BOOL)isConnected;
    // Used internally by the adaptor and channel.

- (BOOL)oracleChannelWillBeginFetching:(OracleChannel *)cursor;
- (void)oracleChannelDidEndFetching:(OracleChannel *)cursor;
- (void)oracleChannelWillOpen:(OracleChannel *)cursor;
- (void)oracleChannelDidClose:(OracleChannel *)cursor;
    // Methods to notify the OracleContext of changes in the OracleChannel
@end

