//  SybaseSQLExpression.h
//  Copyright 1994, NeXT Software, Inc.

#import <EOAccess/EOAccess.h>

/*
** This class is here to do special support for single outer joins and
**  to support HOLDLOCK on selectForUpdate.
*/
@interface SybaseSQLExpression:EOSQLExpression
{
}

// All of the methods for SybaseSQLExpression are required method 
// overrides of methods defined on EOSQLExpression.

+ (NSString *)formatValue:(id)value forAttribute:(EOAttribute *)attribute;
    // returns a formatted string representation of value that is
    // suitable for use in a sybase sql statement

+ (int)serverTypeIdForName:(NSString *)typeName;
    // For a given type name ("char", "int", "decimal", etc.), return the
    // sybase type code (47, 56, 55, etc.)

- (NSString *)lockClause;
    // returns @"HOLDLOCK"

@end
