#
#                              aggregate.make
#

default_rule: all

include $(MAKEFILEDIR)/common.make
-include $(LOCAL_MAKEFILEDIR)/aggregate.make.preamble

recurse_vars = \
	"OBJROOT = $(OBJROOT)" \
	"SYMROOT = $(SYMROOT)" \
	"DSTROOT = $(DSTROOT)" \
	"SRCROOT = $(SRCROOT)" \
	"PROJECT_HEADERS_DIR_NAME = $(PROJECT_HEADERS_DIR_NAME)" \
	"SKIP_EXPORTING_HEADERS = $(SKIP_EXPORTING_HEADERS)" \
	"TOP_PRODUCT_ROOT = $(SYMROOT)" \
	"MAKEFILEDIR = $(MAKEFILEDIR)" \
	"RC_CFLAGS = $(RC_CFLAGS)" \
	"RC_ARCHS = $$archs" \
	"TARGET_ARCHS = $$archs" \
	$(aggregate_recursion_exported_vars)

TARGET_ARCH = all

all debug profile::
	@$(process_target_archs) ; \
	 $(MAKE) recurse_for_subprojects \
		"BUILD_TARGET = $@" \
		"ONLY_SUBPROJECTS = `$(CHANGES) $(SYMROOT)/$(CHANGES_FILE_BASE).$(TARGET_ARCH) $@ $(ALL_SUBPROJECTS)`" \
		$(recurse_vars)

install installhdrs::
	@($(set_should_build) ; \
	if [ "$$should_build" = "yes" ] ; then \
	   $(process_target_archs) ; \
	   $(MAKE) recurse_for_subprojects \
		"BUILD_TARGET = $@" \
		"ONLY_SUBPROJECTS = $(ALL_SUBPROJECTS)" \
		$(recurse_vars) ; \
	fi)

recurse_for_subprojects::
	@(subdirectories="$(ONLY_SUBPROJECTS)" ; \
	target="$(BUILD_TARGET)"; \
	beginning_msg="Making $(BUILD_TARGET) in" ; \
	ending_msg="Finished $(BUILD_TARGET) in" ; \
	$(recurse_on_subdirectories))


projectType_specific_exported_vars = \
	"SYMROOT = $(SYMROOT)/$$sub.derived"   \
	"OBJROOT = $(OBJROOT)/$$sub.derived"   \
	"SRCROOT = $(SRCROOT)/$$sub"

.PHONY : always

$(ALL_SUBPROJECTS): always
	@($(process_target_archs) ; \
	if [ -n "$(BUILD_TARGET)" ] ; then \
	    build_target=$(BUILD_TARGET); \
	else \
	    build_target=all; \
	fi; \
	$(MAKE) recurse_for_subprojects \
	    "BUILD_TARGET = $$build_target" \
	    "ONLY_SUBPROJECTS = $@" \
	    $(recurse_vars))

always:

-include $(LOCAL_MAKEFILEDIR)/aggregate.make.postamble
