

#import <foundation/NSObject.h>
#import <foundation/NSValue.h>
#import <foundation/NSString.h>
#import <remote/NXProxy.h>

#ifdef WIN32
#import <foundation/NSDistantObject.h>
#endif

#define NSVal(x) ({ typeof(x) __y = x; \
	[NSValue value:(void*)&__y withObjCType:@encode(typeof(x))]; })

@protocol OLEObject <NXReference>
- retain;
- (void)release;
- setProtocolForProxy:(Protocol*)proto;
- (void)setOLEPropertyNamed:(NSString*)name to:(NSValue*)val;
- (NSValue*)getOLEPropertyNamed:(NSString*)name ;
@end

@protocol NEXTORB <NXReference>
- retain;
- (void)release;
- (id)objectWithRegisteredName:(NSString*)name 
	                 protocol:(NSString*)proto 
 			            host:(NSString*)host;
- setProtocolForProxy:(Protocol*)proto;
@end

@protocol OLEEnumerator <OLEObject>
- (NSValue*)nextValue;
- (id <OLEObject>)nextObject;
@end

@protocol OLECollection <OLEObject>
- (id <OLEEnumerator>)objectEnumerator;
@end

// 
// "value" returns NSValue with char*
//
@interface NSString (OLEValueProperty)
- (NSValue*) getOLEPropertyNamed:(NSString*)name;@end

//
// "value" return self
//
@interface NSValue (OLEValueProperty)- (NSValue*) getOLEPropertyNamed:(NSString*)name;
@end


#ifdef WIN32
//
// We need a special OLE object proxy to boost performance
// with Distributed OLE.
//
@interface NSDistantIDispatchProxy : NSDistantObject
{ BOOL hasProtocol; }
@end
#endif

